'Color Picker - Javascript Enhanced DHMTL Color Picker Composite Web Server Control (ASP.NET 2.0)
'
'Written By William Severance, WESNet Designs
'
'Date Last Modified: April 9, 2006
'
'Website: http://www.wesnetdesigns.com
'E-Mail: imagemaker@wesnetdesigns.com

'NOTE:  This control makes use of the excellent Javascript library code written by Matt Kruse
'and available for free use. For more information on the ColorPicker script and other scripts,
'please visit http://www.mattkruse.com.

'Disclaimer: This software is provided without charge "AS IS" with no warranties of any kind. The entire risk
'arising out of the use or performance of the software is with you.

Imports System
Imports System.ComponentModel
Imports System.Web.UI.Design
Imports System.Text
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Drawing

<Assembly: WebResource("WESNet.WebControls.ColorPicker2.js", "application/x-javascript")> 

<DefaultProperty("Value"), DefaultEvent("ColorChanged"), ValidationProperty("Value"), _
 Designer(GetType(ColorPickerDesigner)), ToolboxData("<{0}:ColorPicker runat=server />")> _
Public Class ColorPicker
    Inherits System.Web.UI.WebControls.CompositeControl
    Implements IPostBackEventHandler

    Protected WithEvents tbColorValue As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblColorCell As System.Web.UI.WebControls.Label

    Public Enum LayoutModes
        Flow = 0
        Table
    End Enum

    <Bindable(True), Category("Behavior"), DefaultValue(False), Browsable(True)> _
    Public Property AutoPostBack() As Boolean
        Get
            If ViewState("AutoPostBack") Is Nothing Then
                Return False
            Else
                Return CType(ViewState("AutoPostBack"), Boolean)
            End If
        End Get
        Set(ByVal value As Boolean)
            ViewState("AutoPostBack") = value
        End Set
    End Property

    <Bindable(True), Category("Data"), DefaultValue(""), Browsable(True)> _
    Public Property Value() As String
        Get
            EnsureChildControls()
            Return tbColorValue.Text
        End Get
        Set(ByVal Value As String)
            EnsureChildControls()
            SetColorCell(Value)
        End Set
    End Property

    <Bindable(False), Category("Appearance"), DefaultValue(GetType(LayoutModes), "Flow"), Browsable(True)> _
    Public Property LayoutMode() As ColorPicker.LayoutModes
        Get
            If ViewState("LayoutMode") Is Nothing Then
                Return ColorPicker.LayoutModes.Flow
            Else
                Return CType(ViewState("LayoutMode"), ColorPicker.LayoutModes)
            End If
        End Get
        Set(ByVal value As ColorPicker.LayoutModes)
            ViewState("LayoutMode") = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(GetType(Color), "Black"), Browsable(True)> _
       Public Property ColorCellBorderColor() As Color
        Get
            EnsureChildControls()
            Return lblColorCell.BorderColor
        End Get
        Set(ByVal value As Color)
            EnsureChildControls()
            lblColorCell.BorderColor = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(GetType(Unit), "1px"), Browsable(True)> _
    Public Property ColorCellBorderWidth() As Unit
        Get
            EnsureChildControls()
            Return lblColorCell.BorderWidth
        End Get
        Set(ByVal value As Unit)
            EnsureChildControls()
            lblColorCell.BorderWidth = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(GetType(System.Web.UI.WebControls.BorderStyle), "Solid"), Browsable(True)> _
    Public Property ColorCellBorderStyle() As System.Web.UI.WebControls.BorderStyle
        Get
            EnsureChildControls()
            Return lblColorCell.BorderStyle
        End Get
        Set(ByVal value As System.Web.UI.WebControls.BorderStyle)
            EnsureChildControls()
            lblColorCell.BorderStyle = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(GetType(Unit), "20px"), Browsable(True)> _
        Public Property ColorCellHeight() As Unit
        Get
            EnsureChildControls()
            Return lblColorCell.Height
        End Get
        Set(ByVal value As Unit)
            EnsureChildControls()
            lblColorCell.Height = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(GetType(Unit), "20px"), Browsable(True)> _
            Public Property ColorCellWidth() As Unit
        Get
            EnsureChildControls()
            Return lblColorCell.Width
        End Get
        Set(ByVal value As Unit)
            EnsureChildControls()
            lblColorCell.Width = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(2), Browsable(True)> _
        Public Property CellPadding() As Integer
        Get
            If ViewState("CellPadding") Is Nothing Then
                Return 2
            Else
                Return CType(ViewState("CellPadding"), Integer)
            End If
        End Get
        Set(ByVal value As Integer)
            ViewState("CellPadding") = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(3), Browsable(True)> _
        Public Property CellSpacing() As Integer
        Get
            If ViewState("CellSpacing") Is Nothing Then
                Return 3
            Else
                Return CType(ViewState("CellSpacing"), Integer)
            End If
        End Get
        Set(ByVal value As Integer)
            ViewState("CellSpacing") = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(GetType(Unit), "60px"), Browsable(True)> _
    Public Property ValueBoxWidth() As Unit
        Get
            EnsureChildControls()
            Return tbColorValue.Width
        End Get
        Set(ByVal value As Unit)
            EnsureChildControls()
            tbColorValue.Width = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(20), Browsable(True)> _
    Public Property ValueBoxMaxLength() As Integer
        Get
            EnsureChildControls()
            Return tbColorValue.MaxLength
        End Get
        Set(ByVal value As Integer)
            EnsureChildControls()
            tbColorValue.MaxLength = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(""), Browsable(True)> _
    Public Property ValueBoxCssClass() As String
        Get
            EnsureChildControls()
            Return tbColorValue.CssClass
        End Get
        Set(ByVal value As String)
            EnsureChildControls()
            tbColorValue.CssClass = value
        End Set
    End Property

    <Bindable(True), Category("Appearance"), DefaultValue(""), Browsable(True)> _
    Public Property ColorCellCssClass() As String
        Get
            EnsureChildControls()
            Return lblColorCell.CssClass
        End Get
        Set(ByVal value As String)
            EnsureChildControls()
            lblColorCell.CssClass = value
        End Set
    End Property

    Protected Overrides ReadOnly Property TagKey() As System.Web.UI.HtmlTextWriterTag
        Get
            If LayoutMode = LayoutModes.Flow Then
                Return HtmlTextWriterTag.Div
            Else
                Return HtmlTextWriterTag.Table
            End If
        End Get
    End Property

    Private Sub SetColorCell(ByVal Value As String)
        Dim SelectedColor As Color
        Dim ColorConverter As New WebColorConverter

        If Value Is Nothing Then Value = ""
        Try
            SelectedColor = CType(ColorConverter.ConvertFromString(Value), Color)
            lblColorCell.BackColor = SelectedColor
            tbColorValue.Text = Value
        Catch ex As Exception
            'Eat the exception
        End Try
    End Sub

    Public Overrides ReadOnly Property Controls() As System.Web.UI.ControlCollection
        Get
            EnsureChildControls()
            Return MyBase.Controls
        End Get
    End Property

    Protected Overrides Sub CreateChildControls()

        Controls.Clear()
        Me.ClearChildViewState()

        'Create the ColorValue textbox
        tbColorValue = New TextBox
        With tbColorValue
            .ID = "ColorValue"
            .MaxLength = 20
            .Width = Unit.Pixel(60)
        End With
        Controls.Add(tbColorValue)

        'Create the ColorCell sample as a Label - will render as a SPAN
        lblColorCell = New Label
        With lblColorCell
            .ID = "ColorCell"
            .Height = Unit.Pixel(20)
            .Width = Unit.Pixel(20)
            .BorderColor = Color.Black
            .BorderWidth = Unit.Pixel(1)
            .BorderStyle = UI.WebControls.BorderStyle.Solid
            .BackColor = Color.White
            .Text = "&nbsp;"
        End With
        Controls.Add(lblColorCell)
    End Sub

    Public Event ColorChanged(ByVal sender As Object, ByVal e As System.EventArgs)

    Private Sub ColorPicker_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        Page.ClientScript.RegisterClientScriptResource(GetType(ColorPicker), "WESNet.WebControls.ColorPicker2.js")
        If Not Page.ClientScript.IsClientScriptBlockRegistered(GetType(ColorPicker), "CPInitialize") Then Page.ClientScript.RegisterClientScriptBlock(GetType(ColorPicker), "CPInitialize", "var cp = new ColorPicker(); cp.writeDiv();", True)

        Dim PostBackEventReference As String = String.Empty
        If AutoPostBack Then
            PostBackEventReference = Page.ClientScript.GetPostBackEventReference(Me, Me.ID)
        End If
        tbColorValue.Attributes.Add("onchange", "javascript: cp.update('" & ClientID & "', """ & PostBackEventReference & """);")
        lblColorCell.Attributes.Add("onclick", "javascript: cp.select('" & ClientID & "', """ & PostBackEventReference & """);")

        SetColorCell(Value)
    End Sub

    Protected Overrides Sub AddAttributesToRender(ByVal writer As System.Web.UI.HtmlTextWriter)
        MyBase.AddAttributesToRender(writer)
        If LayoutMode = LayoutModes.Flow Then
            writer.AddStyleAttribute("padding", CellPadding.ToString & "px")
            writer.AddStyleAttribute("display", "inline")
            writer.AddStyleAttribute("height", CInt(ColorCellHeight.Value + 2 * CellPadding + 2 * CellSpacing + 2).ToString & "px")
        Else
            writer.AddAttribute("cellpadding", CellPadding.ToString)
            writer.AddAttribute("cellspacing", CellSpacing.ToString)
            writer.AddAttribute("rules", "none")
            writer.AddStyleAttribute("border-collapse", "collapse")
        End If
    End Sub

    Protected Overrides Sub RenderContents(ByVal writer As System.Web.UI.HtmlTextWriter)
        If LayoutMode = LayoutModes.Flow Then
            writer.AddStyleAttribute("vertical-align", "middle")
            tbColorValue.RenderControl(writer)
            writer.AddStyleAttribute("width", (CellSpacing + 2 * CellPadding).ToString & "px")
            writer.AddStyleAttribute("display", "inline-block")
            writer.RenderBeginTag("span")
            writer.Write("&nbsp;")
            writer.RenderEndTag()
            writer.AddStyleAttribute("display", "inline-block")
            writer.AddStyleAttribute("vertical-align", "middle")
            writer.AddStyleAttribute("padding-bottom", "1px")
            lblColorCell.RenderControl(writer)
        Else
            writer.AddAttribute(HtmlTextWriterAttribute.Valign, "middle")
            writer.AddAttribute(HtmlTextWriterAttribute.Height, ColorCellHeight.ToString)
            writer.RenderBeginTag(HtmlTextWriterTag.Tr)
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            tbColorValue.RenderControl(writer)
            writer.RenderEndTag()
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            writer.AddStyleAttribute("display", "inline-block")
            writer.AddStyleAttribute("vertical-align", "middle")
            writer.AddStyleAttribute("padding-bottom", "1px")
            lblColorCell.RenderControl(writer)
            writer.RenderEndTag()
            writer.RenderEndTag()
        End If
    End Sub

    Public Sub RaisePostBackEvent(ByVal eventArgument As String) Implements System.Web.UI.IPostBackEventHandler.RaisePostBackEvent
        RaiseEvent ColorChanged(Me, New System.EventArgs)
    End Sub
End Class

#Region "ColorPickerDesigner"
<ToolboxItem(False)> _
Public Class ColorPickerDesigner
    Inherits ControlDesigner

    Public Overrides Function GetDesignTimeHtml() As String
        Dim DesignTimeHtml As String
        Dim ControlToDesign As ColorPicker = CType(Component, ColorPicker)
        Dim Controls As ControlCollection = ControlToDesign.Controls
        DesignTimeHtml = MyBase.GetDesignTimeHtml()
        If DesignTimeHtml.Length = 0 Then DesignTimeHtml = GetEmptyDesignTimeHtml()
        Return DesignTimeHtml
    End Function
End Class

#End Region 'ColorPickerDesigner




